(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/router'), require('rxjs/observable/fromEvent'), require('rxjs/observable/of'), require('rxjs/observable/merge'), require('rxjs/operators')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@angular/router', 'rxjs/observable/fromEvent', 'rxjs/observable/of', 'rxjs/observable/merge', 'rxjs/operators'], factory) :
	(factory((global.ngxPwaOffline = global.ngxPwaOffline || {}),global.ng.core,global.ng.common,global.ng.router,global.Rx.Observable,global.Rx.Observable,global.Rx.Observable,global.Rx.operators));
}(this, (function (exports,_angular_core,_angular_common,_angular_router,rxjs_observable_fromEvent,rxjs_observable_of,rxjs_observable_merge,rxjs_operators) { 'use strict';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 */

/**
 * @record
 */

var OFFLINE_CONFIG_DEFAULT = {
    routeOffline: '/offline',
    routeUnavailable: '/unavailable',
    guardsRedirect: true
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var OFFLINE_CONFIG_ROUTE_OFFLINE = new _angular_core.InjectionToken('offline-config-route-offline');
var OFFLINE_CONFIG_ROUTE_UNAVAILABLE = new _angular_core.InjectionToken('offline-config-route-unavailable');
var OFFLINE_CONFIG_GUARDS_REDIRECT = new _angular_core.InjectionToken('offline-config-guards-redirect');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var Offline = (function () {
    function Offline(router, platformId, routeOffline, routeUnavailable, guardsRedirect) {
        if (routeOffline === void 0) { routeOffline = OFFLINE_CONFIG_DEFAULT.routeOffline; }
        if (routeUnavailable === void 0) { routeUnavailable = OFFLINE_CONFIG_DEFAULT.routeUnavailable; }
        if (guardsRedirect === void 0) { guardsRedirect = OFFLINE_CONFIG_DEFAULT.guardsRedirect; }
        this.router = router;
        this.platformId = platformId;
        this.routeOffline = routeOffline;
        this.routeUnavailable = routeUnavailable;
        this.guardsRedirect = guardsRedirect;
        /* Store instance in a static property to allow access to injected services in the RxJS static operator */
        Offline.instance = this;
        this.initConnectionObservable();
    }
    Object.defineProperty(Offline.prototype, "isOnline", {
        get: /**
         * @return {?}
         */
        function () {
            return _angular_common.isPlatformBrowser(this.platformId) ? navigator.onLine : true;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @template T
     * @return {?}
     */
    Offline.catch = /**
     * @template T
     * @return {?}
     */
    function () {
        return rxjs_operators.catchError(Offline.catchCallback);
    };
    /**
     * @template T
     * @param {?} error
     * @param {?} caught
     * @return {?}
     */
    Offline.catchCallback = /**
     * @template T
     * @param {?} error
     * @param {?} caught
     * @return {?}
     */
    function (error, caught) {
        if (!Offline.instance) {
            console.log('You need to import OfflineModule in your AppModule AND to inject the Offline service in your AppComponent constructor.');
            throw error;
        }
        else {
            var /** @type {?} */ cancel = caught.pipe(rxjs_operators.filter(function () { return false; }));
            if (!Offline.instance.isOnline) {
                Offline.instance.router.navigate([Offline.instance.routeOffline]);
                return cancel;
            }
            else if (error.status && (error.status >= 500 && error.status < 600)) {
                Offline.instance.router.navigate([Offline.instance.routeUnavailable]);
                return cancel;
            }
            else {
                throw error;
            }
        }
    };
    /**
     * @return {?}
     */
    Offline.prototype.canActivate = /**
     * @return {?}
     */
    function () {
        return this.guard();
    };
    /**
     * @return {?}
     */
    Offline.prototype.canActivateChild = /**
     * @return {?}
     */
    function () {
        return this.guard();
    };
    /**
     * @return {?}
     */
    Offline.prototype.canLoad = /**
     * @return {?}
     */
    function () {
        return this.guard();
    };
    /**
     * @return {?}
     */
    Offline.prototype.initConnectionObservable = /**
     * @return {?}
     */
    function () {
        this.connectionChanges = !_angular_common.isPlatformBrowser(this.platformId) ? rxjs_observable_of.of(true) : rxjs_observable_merge.merge(rxjs_operators.startWith(this.isOnline), rxjs_observable_fromEvent.fromEvent(document, 'online').pipe(rxjs_operators.mapTo(true)), rxjs_observable_fromEvent.fromEvent(document, 'offline').pipe(rxjs_operators.mapTo(false)));
    };
    /**
     * @return {?}
     */
    Offline.prototype.guard = /**
     * @return {?}
     */
    function () {
        if (!this.isOnline) {
            if (this.guardsRedirect) {
                this.router.navigate([this.routeOffline]);
            }
            return false;
        }
        return true;
    };
    Offline.instance = null;
    Offline.decorators = [
        { type: _angular_core.Injectable },
    ];
    /** @nocollapse */
    Offline.ctorParameters = function () { return [
        { type: _angular_router.Router, },
        { type: undefined, decorators: [{ type: _angular_core.Inject, args: [_angular_core.PLATFORM_ID,] },] },
        { type: undefined, decorators: [{ type: _angular_core.Inject, args: [OFFLINE_CONFIG_ROUTE_OFFLINE,] },] },
        { type: undefined, decorators: [{ type: _angular_core.Inject, args: [OFFLINE_CONFIG_ROUTE_UNAVAILABLE,] },] },
        { type: undefined, decorators: [{ type: _angular_core.Inject, args: [OFFLINE_CONFIG_GUARDS_REDIRECT,] },] },
    ]; };
    return Offline;
}());
var catchOffline = Offline.catch;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ɵ0 = OFFLINE_CONFIG_DEFAULT.routeOffline;
var ɵ1 = OFFLINE_CONFIG_DEFAULT.routeOffline;
var ɵ2 = OFFLINE_CONFIG_DEFAULT.guardsRedirect;
var OfflineModule = (function () {
    function OfflineModule() {
    }
    /**
     * @param {?=} userConfig
     * @return {?}
     */
    OfflineModule.forRoot = /**
     * @param {?=} userConfig
     * @return {?}
     */
    function (userConfig) {
        if (userConfig === void 0) { userConfig = {}; }
        return {
            ngModule: OfflineModule,
            providers: [
                { provide: OFFLINE_CONFIG_ROUTE_OFFLINE, useValue: userConfig.routeOffline },
                { provide: OFFLINE_CONFIG_ROUTE_UNAVAILABLE, useValue: userConfig.routeUnavailable },
                { provide: OFFLINE_CONFIG_GUARDS_REDIRECT, useValue: userConfig.guardsRedirect },
            ]
        };
    };
    OfflineModule.decorators = [
        { type: _angular_core.NgModule, args: [{
                    providers: [
                        { provide: OFFLINE_CONFIG_ROUTE_OFFLINE, useValue: ɵ0 },
                        { provide: OFFLINE_CONFIG_ROUTE_UNAVAILABLE, useValue: ɵ1 },
                        { provide: OFFLINE_CONFIG_GUARDS_REDIRECT, useValue: ɵ2 },
                        Offline,
                    ]
                },] },
    ];
    return OfflineModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

exports.Offline = Offline;
exports.catchOffline = catchOffline;
exports.OfflineModule = OfflineModule;
exports.ɵa = OFFLINE_CONFIG_DEFAULT;
exports.ɵd = OFFLINE_CONFIG_GUARDS_REDIRECT;
exports.ɵb = OFFLINE_CONFIG_ROUTE_OFFLINE;
exports.ɵc = OFFLINE_CONFIG_ROUTE_UNAVAILABLE;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-pwa-offline.umd.js.map
